%define bin(f0,f1, f2,f3) (f0 | f1<<2 | f2<<4 | f3<<6)
%define _MM_SHUFFLE(z,y,x,w) ((z << 6) | (y <<4) | (x << 2) | w)

%define movint CVTSI2SS

segment .data use32 align=16
align 16

PI2 dd 6.28318530717958647692
    dd 6.28318530717958647692
    dd 6.28318530717958647692
    dd 6.28318530717958647692
   
f20log10: dd 8.68588984, 8.68588984, 8.68588984, 8.68588984 ; 20*log10(9) / log(9)
i20:      dd 20.0

segment .text
global GoertzelSSE

struc MYDATA
.samples    resd 1 ; in float*
.count      resd 1 ; in int
.samplerate resd 1 ; in int
.unused     resd 1 ; align .frequency to 0x10
.frequency  resd 4 ; in float
; output
.theta
.gain       resd 4 ; output in dB
.C0         resd 4 ; private for GoertzelSSE
._C02       resd 4
.S0         resd 4
.CN         resd 4
.SN         resd 4
endstruc


GoertzelSSE: ; MYDATA*
	mov eax,[esp+4]
	%define MYDATA(x)   [eax+MYDATA. %+ x]
	%define MYDATA(x,y) [eax+MYDATA. %+ x + (y*4)]
	; theta[] = 6.28318530717958647692 * frequency[] / samplerate
	movaps xmm0, [PI2]
	mulps  xmm0, MYDATA(frequency) ; = 2*PI*frequency
	movint xmm1, MYDATA(samplerate)
	shufps xmm1,xmm1,bin(0,0,0,0)
	divps  xmm0,xmm1               ; 2*PI*frequency/samplerate
	movaps MYDATA(theta),xmm0
	emms
	; ----------------------------
	; C0[] = cos(theta[])
	; _C02[] = 2.0*C0[]
	; S0[] = sin(theta[])
	fld   dword MYDATA(theta,0)
	fsincos
	fst   dword MYDATA(C0,0) ; cos(theta[0])
	fadd  st0,st0            ; 2*cos(theta[0])
	fstp  dword MYDATA(_C02,0)
	fstp  dword MYDATA(S0,0) ; sin(theta[0])
	;-----------------------------
	fld   dword MYDATA(theta,1)
	fsincos
	fst   dword MYDATA(C0,1) ; cos(theta[1])
	fadd  st0,st0            ; 2*cos(theta[1])
	fstp  dword MYDATA(_C02,1)
	fstp  dword MYDATA(S0,1) ; sin(theta[1])
	;-----------------------------
	fld   dword MYDATA(theta,2)
	fsincos
	fst   dword MYDATA(C0,2) ; cos(theta[2])
	fadd  st0,st0            ; 2*cos(theta[2])
	fstp  dword MYDATA(_C02,2)
	fstp  dword MYDATA(S0,2) ; sin(theta[2])
	;-----------------------------
	fld   dword MYDATA(theta,3)
	fsincos
	fst   dword MYDATA(C0,3) ; cos(theta[3])
	fadd  st0,st0            ; 2*cos(theta[3])
	fstp  dword MYDATA(_C02,3)
	fstp  dword MYDATA(S0,3) ; sin(theta[3])
	;-----------------------------
	fild  dword MYDATA(count)
	fld1
	fsubp st1,st0 ; N-1
	;
	fld st0 ; N-1
	fmul dword MYDATA(theta,0)
	fsincos
	fstp dword MYDATA(CN,0)
	fstp dword MYDATA(SN,0)
	;
	fld st0 ; N-1
	fmul dword MYDATA(theta,1)
	fsincos
	fstp dword MYDATA(CN,1)
	fstp dword MYDATA(SN,1)
	;
	fld st0 ; N-1
	fmul dword MYDATA(theta,2)
	fsincos
	fstp dword MYDATA(CN,2)
	fstp dword MYDATA(SN,2)
	;
	fmul dword MYDATA(theta,3)
	fsincos
	fstp dword MYDATA(CN,3)
	fstp dword MYDATA(SN,3)

	;-----------------------------
	mov edx,MYDATA(samples)
	mov ecx,MYDATA(count)

.a:	; alignment
	test edx,15
	jz .ok
	inc edx
	dec ecx
	jmp .a
.ok
	shr ecx,2
	%define C02 xmm4
	%define u0  xmm5
	%define u1  xmm6
	%define u2  xmm7
	;
;	xmm4 = C02
	movaps C02,MYDATA(_C02)
;	u0 = 0.0;
;	u1 = 0.0;
;	for( _n = 0; _n < N; _n++ )
;	{
;		u2 = *q[_n] + xmm4*u1 - u0;
;		u0 = u1;
;		u1 = u2;
;	}

	subps u0,u0
	subps u1,u1
for:
	; load four floats
	movaps xmm0, [edx]
	;------------------------------- first float xmm7
	movaps u2,xmm0
	shufps u2,xmm0,bin(0,0,0,0)
	;xmm2 = C02*u1 - u0
	movaps xmm2,C02
	mulps  xmm2,u1
	subps  xmm2,u0
	;u2 = xmm1+xmm2
	addps u2,xmm2
	;
	movaps u0,u1
	movaps u1,u2
	;------------------------------- second float
	movaps u2,xmm0
	shufps u2,xmm0,bin(1,1,1,1)
	;xmm2 = C02*u1 - u0
	movaps xmm2,C02
	mulps  xmm2,u1
	subps  xmm2,u0
	;u2 = xmm1+xmm2
	addps u2,xmm2
	;
	movaps u0,u1
	movaps u1,u2
	;------------------------------- third float
	movaps u2,xmm0
	shufps u2,xmm0,bin(2,2,2,2)
	;xmm2 = C02*u1 - u0
	movaps xmm2,C02
	mulps  xmm2,u1
	subps  xmm2,u0
	;u2 = xmm1+xmm2
	addps u2,xmm2
	;
	movaps u0,u1
	movaps u1,u2
	;------------------------------- fourth float
	movaps u2,xmm0
	shufps u2,xmm0,bin(3,3,3,3)
	;xmm2 = C02*u1 - u0
	movaps xmm2,C02
	mulps  xmm2,u1
	subps  xmm2,u0
	;u2 = xmm1+xmm2
	addps u2,xmm2
	;
	movaps u0,u1
	movaps u1,u2
	
	add edx,16
	sub ecx,1
	jnz for

;	%define u0  xmm5
;	%define u2  xmm7
	%define yr  xmm7
	%define yi  xmm6

	;yr[] = u2[] - C0[] * u0[];    hint: u2 is used only here, so rename it to yr
	movaps xmm0,MYDATA(C0)
	mulps  xmm0,u0
	subps  u2,xmm0            ;    u2 = yr = result
	;yi[] = S0[] * u0[];
	movaps yi,MYDATA(S0)
	mulps  yi,u0

;	%define yr  xmm7
;	%define yi  xmm6
	%define cn  xmm5
	%define sn  xmm4
	%define Qr  xmm3
	%define Qi  xmm2
	movaps cn,MYDATA(CN)
	movaps sn,MYDATA(SN)
	;Qr[] = yr[]*CN[] + yi[]*SN[];
	movaps Qr,yr
	mulps  Qr,cn
	movaps xmm0,yi
	mulps  xmm0,sn
	addps  Qr,xmm0
	;Qi[] = yi[]*CN[] - yr[]*SN[];
	movaps Qi,yi
	mulps  Qi,cn
	movaps xmm0,yr
	mulps  xmm0,sn
	subps  Qi,xmm0
	;
	; value[] = sqrt(Qr[]*Qr[] + Qi[]*Qi[]) / count;
	%define value xmm0
	mulps Qr,Qr
	mulps Qi,Qi
	addps Qr,Qi
	sqrtps value, Qr
	; value/=count
	movint xmm1,MYDATA(count) ; load int
	movaps xmm2,xmm1
	shufps xmm1,xmm2,bin(0,0,0,0) ; xmm1 = count,count,count,count
	divps  value,xmm1
%ifdef LOG10_FPU
	; save value[] in theta[], for the following FPU code
	movaps MYDATA(theta),value
	emms
%endif
	; return 20 * log10(value[]);

	; log10(x) = log(x) * 0,4342944920
	; 20*log10(x) = log(x) * 8,68588984
%ifdef LOG10_FPU
	fld1
	fld dword MYDATA(theta,0)
	fyl2x              ; st1 = 1*log(theta); pop
	fldl2t             ; log(10)
	fdivp st1, st0     ; log(theta) / log(10)
	fmul dword[i20]
	fstp dword MYDATA(gain,0)
	;
	fld1
	fld dword MYDATA(theta,1)
	fyl2x
	fldl2t
	fdivp st1, st0
	fmul dword[i20]
	fstp dword MYDATA(gain,1)
	;
	fld1
	fld dword MYDATA(theta,2)
	fyl2x
	fldl2t
	fdivp st1, st0
	fmul dword[i20]
	fstp dword MYDATA(gain,2)
	;
	fld1
	fld dword MYDATA(theta,3)
	fyl2x
	fldl2t
	fdivp st1, st0
	fmul dword[i20]
	fstp dword MYDATA(gain,3)
%else
	call   am_log_ps
	mulps  xmm0,[f20log10] ; transform log() to 20*log10()
	movaps MYDATA(gain),xmm0
	emms
%endif
	ret 4

;
; from AMaths.c (Intel Approximate Math library)
;
segment .data
	align 16
_ps_am_min_norm_pos dd	1.1754944e-38, 1.1754944e-38, 1.1754944e-38, 1.1754944e-38
_ps_am_1	dd 1.0, 1.0, 1.0, 1.0
_epi32_0x7f	dd 7Fh, 7Fh, 7Fh, 7Fh
_ps_log_p1	dd 1.6386665e1, 1.6386665e1, 1.6386665e1, 1.6386665e1
_ps_log_q1	dd 3.1209378e2, 3.1209378e2, 3.1209378e2, 3.1209378e2
_ps_log_c0	dd 6.9314718e-1, 6.9314718e-1, 6.9314718e-1, 6.9314718e-1
_ps_log_q0	dd -3.5672279e1, -3.5672279e1, -3.5672279e1, -3.5672279e1
_ps_log_p2	dd -6.4140999e1, -6.4140999e1, -6.4140999e1, -6.4140999e1
_ps_log_q2	dd -7.6969196e2, -7.6969196e2, -7.6969196e2, -7.6969196e2
_ps_log_p0	dd -7.8958029e-1, -7.8958029e-1, -7.8958029e-1, -7.8958029e-1
_ps_am_inv_mant_mask dd 807FFFFFh

	align 4
am_log_ps:
	maxps	xmm0, [_ps_am_min_norm_pos]  // cut off denormalized stuff
	mov		ecx, esp
	movaps	xmm7, [_ps_am_inv_mant_mask]
	and		ecx, ~15
	movaps	xmm1, [_ps_am_1]
	movaps	[ecx - 16], xmm0

	andps	xmm0, xmm7
	orps	xmm0, xmm1
	movaps	xmm7, xmm0

	addps	xmm7, xmm1
	subps	xmm0, xmm1
	movq	mm0, [ecx - 16]
	rcpps	xmm7, xmm7  
	mulps	xmm0, xmm7
	movq	mm1, [ecx - 16 + 8]
	addps	xmm0, xmm0

	movq	mm7, [_epi32_0x7f]
	movaps	xmm2, xmm0
	mulps	xmm2, xmm2

	movaps	xmm4, [_ps_log_p0]
	psrld	mm1, 23
	movaps	xmm6, [_ps_log_q0]
	psrld	mm0, 23

	mulps	xmm4, xmm2
	movaps	xmm5, [_ps_log_p1]
	mulps	xmm6, xmm2
	movaps	xmm7, [_ps_log_q1]

	addps	xmm4, xmm5
	psubd	mm1, mm7
	addps	xmm6, xmm7
	psubd	mm0, mm7

	movaps	xmm5, [_ps_log_p2]
	mulps	xmm4, xmm2
	cvtpi2ps	xmm1, mm1
	movaps	xmm7, [_ps_log_q2]
	mulps	xmm6, xmm2

	addps	xmm4, xmm5
	shufps	xmm1, xmm1, _MM_SHUFFLE(1,0,1,0)
	addps	xmm6, xmm7

	movaps	xmm5, [_ps_log_c0]
	mulps	xmm4, xmm2
	cvtpi2ps	xmm1, mm0
	rcpps	xmm6, xmm6  

	mulps	xmm4, xmm0
	mulps	xmm1, xmm5
	mulps	xmm4, xmm6

	addps	xmm0, xmm1
	addps	xmm0, xmm4
	ret